%%%%%%%%%% Reinforcement Problem 10.11 %%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Fourth-order modal system ----
%
clear
disp('Reinforcement Problem 10.11')
A = diag([0.9048 0.8187 0.7788 1])
C = [ 1 2 -1 1 ]
p = [0.5 0.65 0.78 0.92]'
L = place(A',C',p)'
A_ob = A-L*C
eig(A_ob)
%
x0 = [1 2 0 1]'   % initial condition
Ts = 0.1
time = [0:Ts:6]';
u = zeros(1,length(time));
B = [0; 0; 0; 0] 
D = 0
G = ss(A,B,C,D,Ts)
[y,t,x] = lsim(G,u,time,x0);
G_ob = ss(A_ob,L,C,D,Ts)
[y_hat,t,x_hat] = lsim(G_ob,y,time);

figure
plot(time,x,'o',time,x_hat,'+');grid
xlabel('Time (s)')
text(4.1,2.7,'o ==> x')
text(4.1,2.2,'+ ==> x\_hat')
title('State responses for Reinforcement Problem 10.11')

figure
plot(time,y,'o',time,y_hat,'+');grid
xlabel('Time (s)')
text(4.1,2.7,'o ==> y')
text(4.1,2.2,'+ ==> y\_hat')
title('Output responses for Reinforcement Problem 10.11')
%%%%%%%%%%