%%%%%%%%%% Reinforcement Problem 10.13 %%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Third-order system ----
%
clear
disp('Reinforcement Problem 10.13')
Ts = 0.1 
A = [ 0.8238     0.0400     0.0810; 
      0.0459     0.7799     0.1161;
      0.0781     0.0020     0.7448]
B = [ 0.0503;    0.0296;    0.0887]
C = [ 0 1 0]
D = 0
Gp = ss(A,B,C,D,Ts)
% (a) design full-state feedback and observer gains
p_s = [0.5 0.65 0.8]'
F = place(A,B,p_s)
A_cl = A-B*F
p_o = [0.3 0.4 0.6]'
L = place(A',C',p_o)'
A_ob = A-L*C
eig(A_ob)
% (b) build observer-controller according to (10.5) and (10.6)
A_oc = A-B*F-L*C
Goc = ss(A_oc,-L,-F,0,Ts)
Goc_poles = pole(Goc);
[magGoc_poles,thetaGoc_poles] = xy2p(Goc_poles)
Goc_zeros = tzero(Goc);
figure, bode(Goc)
GpGc = Gp*Goc
Gcl = feedback(GpGc,1,-1)
cl_loop_poles = pole(Gcl)

%---- (c) pre-gain for unity DC gain ----------
lfg = dcgain(Gcl)
N = 1/lfg
% incorporate N in series with closed-loop system transfer function 
T_ref = N*Gcl;
t = [0:Ts:4];
r = 0*t;
z0 = [1 0.5 -0.25 0 0 0]'      % initial condition
[y,t,z] = lsim(T_ref,r,t,z0);  % IC response
figure
plot(t,z(:,1:3),'o',t,z(:,4:6),'+'), grid
[ys,t,z] = step(T_ref,t);

figure
step(T_ref,t)
%%%%%%%%%%