%%%%%%%%%%%%%%%%%% Example 2.4 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Response due to individual poles ----
%
clear
disp('Example 2.4')
numG = [2 -2.2 0.56];                         % create G(z)
denG = [1 -0.6728 0.0463 0.4860];
[rGoz,pGoz,otherGoz] = residue(numG,[denG 0]) % residues, poles of G(z)/z
disp('*****>'), pause
disp('Poles in polar form')
xy2p(pGoz);            % show poles in polar form
disp('Residues in polar form')
xy2p(rGoz);            % show residues in polar form

dtime = [0:30];                               % sampled time data sequence
ycmplx = cpole2k(pGoz(1),rGoz(1),dtime);      % response due to complex poles
yreal1 = rpole2k(pGoz(3),rGoz(3),dtime);      % response due to 1st real pole
yreal2 = rpole2k(pGoz(4),rGoz(4),dtime);      % response due to 2nd real pole
ytot = ycmplx + yreal1 + yreal2;              % ytot(k) is sum of the three

%----- plot individual responses as separate plots
figure
subplot(3,1,1)       %----- Response due to complex poles -----              
stem(dtime,ycmplx,'filled'),grid
title('Ex. 2.4: Due to complex poles at z = 0.90exp(+/-j0.7854)')
subplot(3,1,2)       %----- Response due to real poles ----- 
stem(dtime,yreal1,'filled'),grid
hold on
stem(dtime,yreal2,'o')
hold off
title('Ex. 2.4: Real poles: z = -0.60 (solid); z = 0 (O)')
subplot(3,1,3)       %----- Complete response -----
stem(dtime,ytot,'filled'),grid
xlabel('k')
title('Ex. 2.4: Complete response')
%%%%%%%%%%