%%%%%%%%%%%%%%%%%% Example 2.7 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Step response from G(z) ----
%
clear
disp('Example 2.7')
numG = [2 -2.2 0.56]                   % create G(z)
denG = [1 -0.6728 0.0463 0.486]        % ...as TF object
G = tf(numG,denG,1)                    % ...with unit sampling period
numGstep = [numG 0]                    % add a zero at z=0 to G(z)
denGstep = conv(denG,[1 -1])           % add a pole at z=1 to G(z)
Gstep = tf(numGstep,denGstep,1)        % create zG(z)/(z-1) as TF object
dtime = [0:50];                        % define discrete time samples
yi = impulse(Gstep,dtime);             % step response via impulse cmd
figure
subplot(2,1,1)
stem(dtime,yi,'filled');grid           % plot impulse response of Gstep(z)
title('Example 2.7: step response via impulse cmd')
[ys,ks] = step(G,dtime);               % step response via step command
subplot(2,1,2)
stem(dtime,ys,'filled');grid           % plot step response of G(z)
title('step response via step command')
xlabel('Time (s)')
disp('DC gain is:')
disp(dcgain(G))                        % DC gain of G(z)
%%%%%%%%%%