%%%%%%%%%%% Reinforcement Problem 2.15 %%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Fourth-order system ---
%
clear
disp('Reinforcement Problem 2.15')
numG = [0.1 0.3 0.4]            % generate G(z) as TF object
denG = [1 0.8 0.3 0.76 0.8]
G = tf(numG,denG,1)             % sampling period = 1.0 s
pG = pole(G)                    % poles of G
[pp,theta] = xy2p(pG)           % magnitudes & angles of poles
k = 0:60;					    % vector of time values
y = impulse(G,k);               % compute delta response of G(z)
figure
stem(k,y,'o');grid       
title('Impulse response for Reinforcement Problem 2.15')
xlabel('Time (s)')
%%%%%%%%%%