%%%%%%%%%%% Reinforcement Problem 2.2 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%	--- Fourth-order System ---
%
% Create G(z) as a TF object and determine some properties
clear
disp('Reinforcement Problem 2.2')
numG  = [0.84 -0.062 -0.156 0.058]   % enter transfer function numerator
denG  = [1 -1.03 0.22 0.094 0.05]    % ...and denominator polynomials
G   = tf(numG,denG,-1)
get(G)                               % Show properties of the TF object
[nn,dd] = tfdata(G,'v')
[zz,pp,kk] = zpkdata(G,'v')          % zeros, poles, & gain from TF object
%-- convert system from TF form to ZPK form
GG = zpk(G)				             % convert to ZPK object
[z,p,k] = zpkdata(GG,'v')            % zeros, poles, & gain from ZPK object
[mag_z,theta_z] = xy2p(z)            % show zeros in polar form
[mag_p,theta_p] = xy2p(p)            % show poles in polar form
figure
ucircle		                         % draw unit circle in z-plane
hold on
pzmap(GG)                            % draw pole-zero plot
hold off
set_xo_size					         % make larger X's and O's
text('Units','norm','Pos',[0.02,0.95],'Str','Reinforcement Problem 2.2')
%%%%%%%%%%