%%%%%%%%%%% Reinforcement Problem 3.5 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    ---- Stable zero-pole cancellation ----
%
clear
disp('Reinforcement Problem 3.5')
Ts = 1;
G1 = tf([2 -1],[1 0.5 0.125],Ts)   % G1 in TF form
denG2 = conv([1 -0.5],[1 -0.25 0.125])
G2 = tf([3 0.5],denG2,Ts)          % G2 in TF form
T = G2*G1                          % series combination in TF form
k = [0:Ts:10];                     % discrete time sequence
y = step(T,k);                     % step response 
figure
stem(k,y,':','filled'); grid   % plot response
title('Step response for Reinforcement Problem 3.5')
xlabel('Discrete time k')

%----- compute poles & zeros of G1, G2, & T ----
[zG1,pG1,kG1] = zpkdata(G1,'v');    % zeros, poles, & gain of G1(z)
[zG2,pG2,kG2] = zpkdata(G2,'v');    % zeros, poles, & gain of G2(z)
[zT,pT,kT] = zpkdata(T,'v');        % zeros, poles, & gain of T(z)
%---- display all zeros in polar form
[magzG1,thetazG1] = xy2p(zG1)
[magzG2,thetazG2] = xy2p(zG2)
[magzT,thetazT] = xy2p(zT)
%---- display all poles in polar form
[magpG1,thetapG1] = xy2p(pG1)
[magpG2,thetapG2] = xy2p(pG2)
[magpT,thetapT] = xy2p(pT)
%%%%%%%%%%
