%%%%%%%%%%% Reinforcement Problem 3.6 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   ---- Common zero & pole outside unit circle ----
%
clear
disp('Reinforcement Problem 3.6')
Ts = 1;
G1 = tf([1 -0.2 -0.24],[1 0.8 -0.53 -0.06],Ts)   % G1 in TF form
G2 = tf([1 1.2],[0.64 0 0.01],Ts)   % G2 in TF form
T = G2*G1                           % series combination in TF form
k = [0:Ts:15];                      % discrete time sequence
y = step(T,k);                      % step response
figure
stem(k,y,':','filled'); grid   % plot response
title('Step response for Reinforcement Problem 3.6')
xlabel('Discrete time k')

%----- compute poles & zeros of G1, G2, & T ----
[zG1,pG1,kG1] = zpkdata(G1,'v');    % zeros, poles, & gain of G1(z)
[zG2,pG2,kG2] = zpkdata(G2,'v');    % zeros, poles, & gain of G2(z)
[zT,pT,kT] = zpkdata(T,'v');        % zeros, poles, & gain of T(z)
kT
%---- display all zeros in polar form
[magzG1,thetazG1] = xy2p(zG1)
[magzG2,thetazG2] = xy2p(zG2)
[magzT,thetazT] = xy2p(zT)
%---- display all poles in polar form
[magpG1,thetapG1] = xy2p(pG1)
[magpG2,thetapG2] = xy2p(pG2)
[magpT,thetapT] = xy2p(pT)
%%%%%%%%%%
