%%%%%%%%%%%%%%%%%% Example 4.2 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Series, parallel, and feedback connections ----
%
clear
disp('Example 4.2')

Ts = 1                     % unity sampling period
A1 = [-0.8 -0.97; 1 0]     % state-space matrices for G1
B1 = [0.45; 0]             
C1 = [0.44 -0.2]
D1 = 0       
disp('******>'), pause 
G1 = ss(A1,B1,C1,D1,Ts)    % build G1 as SS object
disp('******>'), pause 

A2 = [0.95 1; 0 0.8]       % state-space matrices for G2
B2 = [0; 1]      	    
C2 = [0.3 0]
D2 = 0.2                     
disp('******>'), pause 
G2 = ss(A2,B2,C2,D2,Ts)    % build G2 as SS object
disp('******>'), pause 

Gs = G2*G1                 % Series connection Gs(z)
disp('Series connection Gs(z)')
disp('******>'), pause


Gp = G1+G2               % Parallel connection Gp(z)
disp('Parallel connection Gp(z)')
disp('******>'), pause

Gf = feedback(G1,G2)    % Feedback connection Gf(z)
disp('Feedback connection Gf(z)')
%%%%%%%%%%
