%%%%%%%%%%%%%%%%%% Example 4.3 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Eigenvalues and transmission zeros ----
%
clear
disp('Example 4.3')
Ts = 1                                  % sampling Interval (sec)
A = [0 1 0; -0.65 -0.7 1; 0.25 0 0.5] 	% state-space matrices
B = [0; 0; 10], C = [1 0 1], D = 0
disp('******>'), pause
G = ss(A,B,C,D,Ts)                      % build system as SS object
disp('built system as SS LTI object')
disp('******>'), pause

%--- extract zeros, poles & gain from SS object
[zG,pG,kG] = zpkdata(G,'v')             
disp('******>'), pause
%--- convert zeros to polar form and display
disp('zeros, in polar form are:')
[mag_zG,theta_zG] = xy2p(zG);      % zeros in polar form
disp(' ')
%--- convert poles to polar form and display
disp('poles, in polar form are:')
[mag_pG,theta_pG] = xy2p(pG);      % poles in polar form
disp(' ')
disp('zeros, poles & gain from SS form')
disp('******>'), pause

%--- compute zeros using tzero command and convert to polar form
disp('.....zeros, from tzero cmd......')
[mag_zeroG,theta_zeroG] = xy2p(tzero(G));
disp('******>'), pause

%--- compute poles using pole command and convert to polar form
disp('.....poles, from pole cmd......')
[mag_poleG,theta_poleG] = xy2p(pole(G));  % poles in polar form
disp(' ')
disp('******>'), pause

dcgain(G)              % compute DC gain
figure
ucircle                % draw the unit circle
axis equal, hold on
pzmap(G)               % plot zeros & poles in z-plane
axis([-1.4 1.4 -1.4 1.4]); 
hold off
set_xo_size            % use larger X's and O's
%%%%%%%%%%












