%%%%%%%%%%%%%%%%%% Example 4.5 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Modal transformation ----
%
clear
disp('Example 4.5')

%------- build system as SS object ------------------
Ts = 1;                           % sampling interval (sec)
A = [0.8 -0.7 0.6; 1 0 0; 0 1 0]  % state-space model
B = [1; 0; 0]
C = [0 1.5 1]
D = 0
disp('******>'), pause
G  = ss(A,B,C,D,Ts)               % build system as SS object
disp('******>'), pause
[M,Ad] = eig(A)                   % compute eigenvectors & diagnolized A matrix
disp('******>'), pause
disp('Eigenvalues of A in polar form')
[mag_eig,theta_eig] = xy2p([Ad(1,1); Ad(2,2); Ad(3,3)]);
disp('******>'), pause
Bd = inv(M)*B                     % transformed input matrix
Cd = C*M                          % transformed output matrix
disp('******>'), pause
Gm = canon(G,'modal')             % create real modal form as SS object
disp('******>'), pause
[Am,Bm,Cm,Dm] = ssdata(Gm)     
disp('******>'), pause
%------ compute eigenvalues of lower 2x2 block of Am ------
disp('Eigenvalues of diagonal form')
xy2p(eig(Am(2:3,2:3)));    % polar form
%%%%%%%%%%