%%%%%%%%%%% Reinforcement Problem 4.2 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Fourth-order system with nonzero D ----
%
clear
disp('Reinforcement Problem 4.2')
Ts = 0.5;
A = [-0.819 0.148 0.0277 0.00398
       0    0.670 0.255  0.0535
       0    0     0.606  0.238  
       0    0      0     0.368];
B = [0.00111
     0.0210
     0.155
     0.632]; 
C = [1 0 1 0]
D = 0.5;

%------ build as SS model & verify stability --------
Gss  = ss(A,B,C,D,Ts)
disp('pole magnitudes are:')
abs(pole(Gss))
disp('*******>')
pause

%---- convert from SS to TF form & extract abcd matrices
Gtf  = tf(Gss)
Gss1 = ss(Gtf)
[A1,B1,C1,D1] = ssdata(Gss1)
disp('*******>')
pause

%---- convert from SS to ZPK form & extract abcd matrices
Gzpk = zpk(Gss) 
Gss2 = ss(Gzpk)
[A2,B2,C2,D2] = ssdata(Gss2)
%%%%%%%%%%







