%%%%%%%%%%%%%%%%%% Example 5.3 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Frequency components in a sampled signal ----
%
clear
disp('Example 5.3')

fs = 10; Ts = 1/fs;             % sampling at 10 Hz
t = [0:Ts:0.9]';                % time points from 0 to 0.9 sec
e_1 = sin(2*pi*t);              % 1-Hz signal
N = 10;                         % length of data
fr = fft(e_1)/N;                % sampled signal spectrum
fr = imag(fr);                  % extract imaginary part              
fr_paste = [fr; fr; fr];        % continue the spectrum
freq = [0:1:29]';               % extended frequency scale   

figure
dplot(freq,fr_paste);grid
hold on, 
plot([0 30],[0 0]), 
hold off
axis([0 30 -0.6 0.6])
xlabel('Frequency (Hz)')
ylabel('Amplitude')
text(2,0.58,'Imaginary Part of Spectral Coefficients')
axis([0 30 -0.65 0.65])
title('Frequency spectrum of the sample signal e_1^*(t) for Example 5.3')
%%%%%%%%%%