function  y = rpole2t(p,res,t)
%RPOLE2T y = rpole2t(p,res,t) 
%        Performs inverse Laplace transform for a real pole
%        and generates a time function. 
%Inputs: p - real pole
%        res - residue at the real pole
%        t - time vector
%Output: y - time response vector
%
%        The response is computed as y(t) = res * exp(p*t) 

%%%%%%%%%%%%%%%%%%% rpole2t.m %%%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

y = 0*t;
for n=1:length(t),
   y(n) = res*exp(p*t(n));
end
%----- remove any very small imaginary parts
y = real(y);
%%%%%%%%%%